#include <c_ext.h>
#include <carcod.h1>

static code struct _ch4x5 { uchar ch; uchar bm[5]; } ch4x5[] =
  {
   ' ',       0,    0,    0,    0,    0,
   'A',    0x60, 0x90, 0x90, 0xf0, 0x90,
   'B',    0xe0, 0x90, 0xe0, 0x90, 0xe0, 
   'C',    0x70, 0x80, 0x80, 0x80, 0x70,
   'D',    0xe0, 0x90, 0x90, 0x90, 0xe0,
   'E',    0xf0, 0x80, 0xe0, 0x80, 0xf0,
   'F',    0xf0, 0x80, 0xe0, 0x80, 0x80,
   'H',    0x90, 0x90, 0xf0, 0x90, 0x90,
   'Y',    0x90, 0x60, 0x20, 0x20, 0x20,  
   'L',	   0x80, 0x80, 0x80, 0x80, 0xf0,
   'N',    0x90, 0xd0, 0xb0, 0x90, 0x90,
   'O',    0x60, 0x90, 0x90, 0x90, 0x60,
   'P',    0xe0, 0x90, 0xe0, 0x80, 0x80,
   'S',	   0x60, 0x80, 0x60, 0x10, 0x60,
   'T',    0xf8, 0x20, 0x20, 0x20, 0x20,
   '1',    0x20, 0x60, 0x20, 0x20, 0x20,
   '2',    0x60, 0x90, 0x20, 0x40, 0xf0,
   '3',    0xe0, 0x10, 0x60, 0x10, 0xe0,
   '4',    0x20, 0x60, 0xa0, 0xf0, 0x20,
   '5',    0xf0, 0x80, 0xe0, 0x10, 0xe0,
   '6',    0x60, 0x80, 0xe0, 0x90, 0x60,
   '7',    0xf0, 0x10, 0x20, 0x40, 0x40,
   '8',    0x60, 0x90, 0x60, 0x90, 0x60,
   '9',    0x60, 0x90, 0x70, 0x10, 0x60,
   '0',    0x60, 0x90, 0x90, 0x90, 0x60,
   '',    0xe0, 0xa0, 0xe0,    0,    0,
   '.',       0,    0,    0,    0, 0x40,
   ':',       0, 0x40,    0,    0, 0x40,
   '-',       0,    0, 0xf0,    0,    0,
   '=',       0, 0xf0,    0, 0xf0,    0,
   '/',       0, 0x10, 0x20, 0x40, 0x80,
   '%',       0, 0x90, 0x20, 0x40, 0x90,
   '>',    0x40, 0x20, 0x10, 0x20, 0x40,
   '<',    0x10, 0x20, 0x40, 0x20, 0x10
};


static uchar code ramp_up[] = { 0x07, 0x08, 0x10, 0x20, 0xc0 };
static uchar code ramp_down[] = { 0xc0, 0x20, 0x10, 0x08, 0x07 };


uchar code * bm4x5 (uchar ch)
/**************************************************************/
/* return a pointer to bit matrix representing the character  */
/* ch into a font 4 x 5 pixel.							      */
/* If the character is not found returns a pointer to blank   */
/* (first character in the table)							  */
/**************************************************************/
{
 uchar i;
 switch (ch)
   {
    case RAMP_UP:   return ramp_up;
    case RAMP_DOWN: return ramp_down;
    default:
      i = sizeof(ch4x5) / sizeof(struct _ch4x5);
      while ((--i) && (ch4x5[i].ch != ch));
      return ch4x5[i].bm;
   }
}

